unit CNamer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DSGNINTF;


Type
  EComponentNamerError = class(Exception);

  TComponentNamer = Class(TComponent)
  Private
    FNameValue    : String;
    FNameMin      : Integer;
    FComponentList: TStringList;
    FChangeNames  : Boolean;
    Procedure SetComponenter(Value : TStringList);
    Procedure SetFChangeNames(Value : Boolean);
    Function GetFComponentList : TStringList;
  protected
    destructor Destroy; override;
  Public
    FAendreList : TStringList;
    constructor Create(AOwner: TComponent); override;
  published
    Property Componenter: TStringList Read GetFComponentList Write SetComponenter;
    Property NamesValue : String  Read FNameValue Write FNameValue;
    Property MinValue   : Integer Read FNameMin Write FNameMin;
    Property ChangeNames: Boolean Read FChangeNames Write SetFChangeNames Default False;
  End;

procedure Register;

implementation

procedure Error(Text: string);
var
  StackTop: record end;
  Stack: record
    EBP: Integer;
    ReturnAddress: Pointer;
  end absolute StackTop;
begin
  raise EComponentNamerError.Create(Text) at Stack.ReturnAddress;
end;

Destructor TComponentNamer.Destroy;
Begin
  FAendreList.Free;
  FComponentList.Free;
  Inherited;
End;

constructor TComponentNamer.Create(AOwner: TComponent);
Var
  i: Integer;
Begin
  if not (AOwner is TForm) then
    Error('Componentnamer Owner has to be a form!')
  else with AOwner do Begin
    for i := 0 to ComponentCount-1 do Begin
      if Components[i] is TComponentNamer then
        Error('Only one instance of ComponentNamer');
    End;
  End;
  FAendreList := TStringList.Create;
  FComponentList := TStringList.Create;
  with AOwner do Begin
    for i := 0 to ComponentCount-1 do Begin
      if Not(Components[i] is TComponentNamer) then Begin
        FComponentList.Add(Components[i].Name);
      End;
    End;
  End;
  inherited Create(AOwner);
End;

Function TComponentNamer.GetFComponentList : TStringList;
Var I : Integer;
Begin
  FComponentList.Clear;
  With Owner Do Begin
    for i := 0 to ComponentCount-1 do Begin
     if Not(Components[i] is TComponentNamer) then Begin
        FComponentList.Add(Components[i].Name);
      End;
    End;
  End;
  Result := FComponentList;
End;

Procedure TComponentNamer.SetFChangeNames(Value : Boolean);
Var
  I, T : Integer;
Begin
  FChangeNames := Value;
  T := FNameMin;
  If FChangeNames Then Begin
    if FAendreList.Count > 0 Then Begin
      For I := 0 To FAendreList.Count-1 Do Begin
        Owner.FindComponent(FAendreList[I]).Name := FNameValue+IntToStr(T);
        Inc(T);
      End;
    End;
    FChangeNames := FALSE;
  End;
End;

Procedure TComponentNamer.SetComponenter(value : TStringList);
Begin
  FComponentList.Assign(Value);
End;

procedure Register;
Begin
  RegisterComponents ('Jimmys', [TComponentNamer] );
End;

end.
